unit Unit4;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWColor, IWTypes, IWCompLabel,
  Controls, IWVCLBaseControl, IWBaseControl, IWBaseHTMLControl, IWControl,
  IWHTML5Chart, IWCompListbox, IWHTML5Base;

type
  TIWForm4 = class(TIWAppForm)
    TIWHTML5Chart1: TTIWHTML5Chart;
    IWLabel1: TIWLabel;
    IWComboBox1: TIWComboBox;
    IWLabel2: TIWLabel;
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWComboBox1AsyncChange(Sender: TObject; EventParams: TStringList);
    procedure TIWHTML5Chart1AsyncSerieClick(Sender: TObject;
      EventParams: TStringList; SerieIndex, PointIndex: Integer);
    procedure TIWHTML5Chart1AsyncChartClick(Sender: TObject;
      EventParams: TStringList);
  public
    IsDetail: boolean;
    procedure InitMainChart;
    procedure InitDetailChart;
  end;

implementation

{$R *.dfm}

procedure TIWForm4.InitMainChart;
const
  Values: array[0..7] of double = (1500,3000,4500,1700,2100,3300,1100,5000);
var
  I: Integer;
begin
  IsDetail := false;
  TIWHTML5Chart1.Annotations.Clear;
  TIWHTML5Chart1.Caption := 'Sales 2011';
  TIWHTML5Chart1.XAxis.Caption := 'Month';
  TIWHTML5Chart1.Series[0].SelectedIndex := -1;
  TIWHTML5Chart1.Series[0].SerieType := stBar;
  TIWHTML5Chart1.Series[0].Show3D := true;
  TIWHTML5Chart1.Series[0].Items.Clear;
  TIWHTML5Chart1.Series[0].ShowLabels := true;

  TIWHTML5Chart1.Series[0].LineColor := clWebBROWN;
  TIWHTML5Chart1.Series[0].BGColor := clWebGold;
  TIWHTML5Chart1.Series[0].BGColorTo := clWebOrange;
  TIWHTML5Chart1.Series[0].SelectedBGColor := clWebINDIANRED;

  IWComboBox1.ItemIndex := 1;

  for I := 0 to 8 - 1 do
  begin
    with TIWHTML5Chart1.Series[0].Items.Add do
    begin
      Value := Values[i]
    end;
  end;

  TIWHTML5Chart1.Series[0].Items[0].XAxis := 'Jan';
  TIWHTML5Chart1.Series[0].Items[1].XAxis := 'Feb';
  TIWHTML5Chart1.Series[0].Items[2].XAxis := 'Mar';
  TIWHTML5Chart1.Series[0].Items[3].XAxis := 'Apr';
  TIWHTML5Chart1.Series[0].Items[4].XAxis := 'May';
  TIWHTML5Chart1.Series[0].Items[5].XAxis := 'Jun';
  TIWHTML5Chart1.Series[0].Items[6].XAxis := 'Jul';
  TIWHTML5Chart1.Series[0].Items[7].XAxis := 'Aug';

end;

procedure TIWForm4.InitDetailChart;
const
  Values: array[0..3] of double = (1500,3000,4500,2000);
var
  I: Integer;
begin
  if not IsDetail then
  begin
    IsDetail := true;

    TIWHTML5Chart1.Caption := 'Sales '
      + TIWHTML5Chart1.Series[0].Items[TIWHTML5Chart1.Series[0].SelectedIndex].XAxis
      + ' 2011';

    TIWHTML5Chart1.Series[0].SelectedIndex := -1;

    TIWHTML5Chart1.XAxis.Caption := 'Brand';
    TIWHTML5Chart1.Series[0].ShowLabels := false;

    TIWHTML5Chart1.Series[0].SerieType := stBar;
    TIWHTML5Chart1.Series[0].Show3D := true;
    IWComboBox1.ItemIndex := 1;

    TIWHTML5Chart1.Series[0].LineColor := clWebDARKGREEN;
    TIWHTML5Chart1.Series[0].BGColor := clWebLIMEGREEN;
    TIWHTML5Chart1.Series[0].BGColorTo := clWebGREENYELLOW;
    TIWHTML5Chart1.Series[0].SelectedBGColor := clWebGREEN;
    TIWHTML5Chart1.Series[0].SelectedBGColorTo := clWebGREEN;
  end;

    TIWHTML5Chart1.Series[0].Items.Clear;

    for I := 0 to 4 - 1 do
    begin
      with TIWHTML5Chart1.Series[0].Items.Add do
      begin
        Value := Values[i]
      end;
    end;

    TIWHTML5Chart1.Series[0].Items[0].XAxis := 'Audi';
    TIWHTML5Chart1.Series[0].Items[1].XAxis := 'BMW';
    TIWHTML5Chart1.Series[0].Items[2].XAxis := 'Mercedes';
    TIWHTML5Chart1.Series[0].Items[3].XAxis := 'Volkswagen';

    TIWHTML5Chart1.Annotations.Clear;
    if TIWHTML5Chart1.Series[0].SelectedIndex >= 0 then
    begin
      with TIWHTML5Chart1.Annotations.Add do
      begin
        SerieIndex := 0;
        PointIndex := TIWHTML5Chart1.Series[0].SelectedIndex;

        if PointIndex = 0 then
          Caption := 'Top model: A4';
        if PointIndex = 1 then
          Caption := 'Top model: 3 Serie';
        if PointIndex = 2 then
          Caption := 'Top model: C-Klasse';
        if PointIndex = 3 then
          Caption := 'Top model: Golf';

      end;
    end;
end;

procedure TIWForm4.IWAppFormCreate(Sender: TObject);
begin

  //IE
  PageContext.DocType := '<!DOCTYPE html>';

  // initialization
  TIWHTML5Chart1.Hint.Visible := false;
  TIWHTML5Chart1.BGColor := clWebWhite;
  TIWHTML5Chart1.BGColorTo := clWebLightSkyBlue;
  TIWHTML5Chart1.Legend.Position := lpNone;
  TIWHTML5Chart1.YAxis.Caption := 'Number of cars sold';
  TIWHTML5Chart1.YAxis.DecimalPrecision := 0;

  TIWHTML5Chart1.Series.Add;
  TIWHTML5Chart1.Series[0].Show3D := true;
  TIWHTML5Chart1.Series[0].SerieType := stBar;

  InitMainChart;
end;

procedure TIWForm4.IWComboBox1AsyncChange(Sender: TObject;
  EventParams: TStringList);
begin
  if IWComboBox1.ItemIndex = 0 then
  begin
    TIWHTML5Chart1.Series[0].SerieType := stArea;
    TIWHTML5Chart1.Series[0].Show3D := true;
  end;
  if IWComboBox1.ItemIndex = 1 then
  begin
    TIWHTML5Chart1.Series[0].SerieType := stBar;
    TIWHTML5Chart1.Series[0].Show3D := true;
  end;
  if IWComboBox1.ItemIndex = 2 then
  begin
    TIWHTML5Chart1.Series[0].SerieType := stLine;
    TIWHTML5Chart1.Series[0].Show3D := false;
  end;

  TIWHTML5Chart1.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Chart1AsyncChartClick(Sender: TObject;
  EventParams: TStringList);
begin
  InitMainChart;
  TIWHTML5Chart1.AsyncUpdateAllValues;
end;

procedure TIWForm4.TIWHTML5Chart1AsyncSerieClick(Sender: TObject;
  EventParams: TStringList; SerieIndex, PointIndex: Integer);
begin
  InitDetailChart;
  TIWHTML5Chart1.AsyncUpdateAllValues;
end;

initialization
  TIWForm4.SetAsMainForm;

end.
